<template>
  <div class="d-flex flex-column">
    <p>ข้อมูลส่วนตัว</p>
    <div v-if="loading" class="d-flex flex-column card">
      <div class="text-center pa-5">
        <v-avatar color="white" size="100">
          <img v-if="media && imgPath" :src="media + imgPath" alt="ImageMe" />
          <img v-else class="img-else" src="/assets/image/profile.png" alt="Profile Image" />
        </v-avatar>
      </div>
      <div class="d-flex">
        <p>ชื่อผู้ใช้</p>
        <p v-if="userData && userData.username">{{ userData.username }}</p>
        <p v-else>ไม่มีข้อมูล</p>
      </div>
      <div class="d-flex">
        <p>ชื่อ-สกุล</p>
        <p v-if="userData">
          {{ userData.prefix }} {{ userData.firstname }} {{ userData.lastname }}</p>
        <p v-else>ไม่มีข้อมูล</p>
      </div>
    </div>

    <div v-if="loading" class="d-flex flex-column card">
      <div class="d-flex">
        <p>คณะ</p>
        <p v-if="userData && userData.department.faculty.name">{{ userData.department.faculty.name }}</p>
        <p v-else>ไม่มีข้อมูล</p>
      </div>
      <div class="d-flex">
        <p>สาขา</p>
        <p v-if="userData && userData.department.name">{{ userData.department.name }}</p>
        <p v-else>ไม่มีข้อมูล</p>
      </div>
      <div class="d-flex">
        <p>รหัสนักศึกษา</p>
        <p v-if="userData && userData.student_id">{{ userData.student_id }}</p>
        <p v-else>ไม่มีข้อมูล</p>
      </div>
    </div>

    <div v-if="loading" class="d-flex flex-column card">
      <div class="d-flex">
        <p>อีเมล</p>
        <p v-if="userData && userData.email">{{ userData.email }}</p>
        <p v-else>ไม่มีข้อมูล</p>
      </div>
      <div class="d-flex">
        <p>เบอร์โทรศัพท์</p>
        <p v-if="userData && userData.phone_number">{{ userData.phone_number }}</p>
        <p v-else>ไม่มีข้อมูล</p>
      </div>
    </div>
    <v-dialog transition="dialog-top-transition" max-width=400px>
      <template v-if="loading" v-slot:activator="{ props }">
        <v-btn variant="text" class="bg-white mt-2" v-bind="props">
          <p>แก้ไขข้อมูล</p>
        </v-btn>
      </template>
      <template v-slot:default="{ isActive }">
        <v-card rounded="xl">
          <v-form @submit.prevent="onUpdate">
            <v-toolbar color=#fcc200 title="แก้ไขข้อมูลส่วนตัว" class="align-text-center"/>
            <v-card-text class="pb-0 px-6">
              <v-text-field variant="outlined" density="compact" rounded="xl" label="ชื่อผู้ใช้"
                v-model="userName" :rules="[usernameRules.required]"></v-text-field>
              <v-select v-model="preFix" :items="['นาย', 'นางสาว']" label="คำนำหน้า" variant="outlined" rounded="xl"
                density="compact" item-title="attributes.name" item-value="id">
                <template v-slot:item="{ props }">
                  <v-list-item v-bind="props" rounded="xl"></v-list-item>
                </template>
              </v-select>
              <v-text-field variant="outlined" density="compact" rounded="xl" label="ชื่อ"
                v-model="firstName" :rules="[firstnameRules.required]"></v-text-field>
              <v-text-field variant="outlined" density="compact" rounded="xl" label="สกุล"
                v-model="lastName" :rules="[lastnameRules.required]"></v-text-field>
              <v-text-field variant="outlined" density="compact" rounded="xl" label="รหัสนักศึกษา"
                v-model="studentId" :rules="[sidRules.required, sidRules.format]"></v-text-field>
              <v-text-field variant="outlined" density="compact" rounded="xl" label="เบอร์โทรศัพท์" type="number"
                v-model="phoneNumber" :rules="[phonenumberRules.required]" :counter="10"></v-text-field>
            </v-card-text>

            <v-card-actions class="justify-space-evenly pt-0">
              <v-btn variant="text" @click="isActive.value = false" rounded="xl">ยกเลิก</v-btn>
              <v-btn variant="text" type="submit" color="amber-darken-1" rounded="xl"
                @click="isActive.value = false" :disabled="!isFormValid">บันทึก
              </v-btn>
            </v-card-actions>
          </v-form>
        </v-card>
      </template>
    </v-dialog>

    <v-col cols="auto">
      <v-dialog v-model="warning" transition="dialog-top-transition" max-width="275">
        <template v-slot:default>
          <v-card rounded="xl">
            <div class="pb-5 text-center">
              <v-icon class="my-6" color="warning" icon="mdi-alert-circle" size="128"></v-icon>
              <div class="t-text">ชื่อผู้ใช้ถูกใช้งานแล้ว</div>
            </div>
          </v-card>
        </template>
      </v-dialog>
    </v-col>
    <v-col cols="auto">
      <v-dialog v-model="warningSid" transition="dialog-top-transition" max-width="275">
        <template v-slot:default>
          <v-card rounded="xl">
            <div class="pb-5 text-center">
              <v-icon class="my-6" color="warning" icon="mdi-alert-circle" size="128"></v-icon>
              <div class="t-text">รหัสนักศึกษาถูกใช้งานแล้ว</div>
            </div>
          </v-card>
        </template>
      </v-dialog>
    </v-col>

    <div v-if="!loading" class="card d-flex flex-column mb-2">
      <v-skeleton-loader type="card"></v-skeleton-loader>
      <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    </div>
    <div v-if="!loading" class="text-detail mb-2">
      <v-skeleton-loader type="paragraph"></v-skeleton-loader>
    </div>
    <div v-if="!loading" class="text-detail mb-2">
      <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    </div>
    <div v-if="!loading" class="text-detail mb-2">
      <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    </div>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | ข้อมูลส่วนตัว",
  meta: [
    { name: "description", content: "ข้อมูลส่วนตัว" }
  ]
})
definePageMeta({
  middleware: 'auth'
})
import { ref, onMounted } from 'vue';
import axios from 'axios';

const url = useStrapiUrl();
const media = useStrapiMedia();
const token = useStrapiToken();

const userData = ref()

const userId = ref()
const userEmail = ref()
const userName = ref()
const profileId = ref()
const preFix = ref()
const firstName = ref()
const lastName = ref()
const studentId = ref()
const phoneNumber = ref()
const imgPath = ref('')

const department = ref()
const faculty = ref()

const loading = ref(false)
const warning = ref(false)
const warningSid = ref(false)

const usernameRules = {
  required: (value) => !!value || "กรุณากรอกชื่อผู้ใช้",
};
const sidRules = {
  required: (value) => !!value || "กรุณากรอกรหัสนักศึกษา",
  format: (value) => {
    const pattern = /^\d{11,}-\d$/;
    return pattern.test(value) || "รูปแบบไม่ถูกต้อง เช่น xxxxxxxxxxx-x";
  },
};
const firstnameRules = {
  required: (value) => !!value || "กรุณากรอกชื่อ",
};
const lastnameRules = {
  required: (value) => !!value || "กรุณากรอกนามสกุล",
};
const phonenumberRules = {
  required: (value) => !!value || "กรุณากรอกเบอร์โทรศัพท์มือถือ",
};

const isFormValid = computed(() => {
  return (
      !!userName.value &&
      !!studentId.value &&
      !!firstName.value &&
      !!lastName.value &&
      !!phoneNumber.value &&
      isstudentidValid(studentId.value) &&
      isphonenumberValid(phoneNumber.value)
  );
});

const isstudentidValid = (value) => {
  // เช็คว่ามี "-" และตัวเลขลงท้ายหรือไม่
  const pattern = /^\d+-\d$/;
  return pattern.test(value) && value.length >= 13;
};
const isphonenumberValid = (value) =>
    value && value.startsWith("0") && value.length === 10 && !isNaN(value);

async function onUpdate() {
  try {
    // ทำการอัปเดตข้อมูลผู้ใช้
    await axios.put(`${url}/users/${userId.value}`, {
      prefix: preFix.value,
      username: userName.value,
      firstname: firstName.value,
      lastname: lastName.value,
      phone_number: phoneNumber.value,
      student_id: studentId.value
    }, {
      headers: {
        'Authorization': `Bearer ${token.value}`,
      },
    }).then((update) => {
      console.log("update username : ", update.data.username)
    });

    await getUser();

  } catch (error) {
    console.log('เกิดข้อผิดพลาดในการอัปเดตข้อมูล:', error.response.data.error);
    if(error.response.data.error.message === "Username already taken") {
      warning.value = true
      setTimeout(() => (warning.value = false), 3000);
    }
  
    if(error.response.data.error.message === "This attribute must be unique") {
      warningSid.value = true
      setTimeout(() => (warningSid.value = false), 3000);
    }
    await getUser();
  }
}

async function getUser() {
  loading.value = true
  try {
    //ดึงข้อมูลส่วนตัวของ User
    const response = await axios.get(`${url}/users/me`, {
      params: {
        fields: {
          1: 'username',
          2: 'email',
          3: 'prefix',
          4: 'firstname',
          5: 'lastname',
          6: 'student_id',
          7: 'phone_number',
        },
        populate: {
          image: {
            fields: {
              8: 'url',
            },
          },
          department: {
            fields: {
              9: 'name'
            },
            populate: {
              faculty: {
                fields: {
                  10: 'name'
                }
              }
            }
          }
        }
      },
      headers: {
        Authorization: `Bearer ${token.value}`,
      },
    });
    //ข้อมูล User
    userData.value = response.data

    userId.value = response.data.id
    userEmail.value = response.data.email
    userName.value = response.data.username
    //ข้อมูล Profile
    profileId.value = response.data.id
    preFix.value = response.data.prefix
    firstName.value = response.data.firstname
    lastName.value = response.data.lastname
    studentId.value = response.data.student_id
    phoneNumber.value = response.data.phone_number
    if (response.data.image) {
      imgPath.value = response.data.image.url
    }
    //ข้อมูล คณะ สาขา
    faculty.value = response.data.department.faculty.name
    department.value = response.data.department.name

  } catch (error) {
    console.error('Error fetching user data:', error);
  } finally {
    loading.value = true
  }
}

onMounted(async () => {
  await getUser();
});
</script>

<style scoped>
@import url(../assets/css/styles/userdetail.css);
</style>
